<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加行业',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加' : '详情'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          v-if="modalType == 'add'"
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, reactive, ref } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  appName: [{ required: true, message: "请输入行业名称", trigger: "blur" }],
  tdaConfigId: [
    { required: true, message: "请选择loT平台", trigger: "change" },
  ],
  // remark: [{ required: true, message: "请输入备注", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "Iot平台",
    prop: "id",
    data: [],
  },
]);
const config = computed(() => {
  return [
    {
      attrs: {
        label: "loT平台",
        prop: "configName",
      },
    },
    {
      attrs: {
        label: "行业名称",
        prop: "appName",
      },
    },
    {
      attrs: {
        label: "AppId",
        prop: "appId",
      },
    },
    {
      attrs: {
        label: "创建人",
        prop: "createUser",
      },
    },
    {
      attrs: {
        label: "创建时间",
        prop: "createTime",
      },
    },
    {
      attrs: {
        label: "备注",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "查看",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/tdaApplication/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "input",
    prop: "appName",
    label: "行业名称",
    required: true,
    itemType: "text",
  },
  {
    type: "select",
    prop: "tdaConfigId",
    label: "IoT 平台",
    required: true,
    data: [],
  },
  {
    type: "input",
    itemType: "textarea",
    prop: "remark",
    label: "备注",
    required: true,
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/tdaApplication/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};
const selection = ref({
  data: [],
});
const select = (_selection, row) => {
  selection.value.data = _selection;
  console.log(_selection.length);
};
const openRoomModal = () => {
  roomDialogVisible.value = true;

  proxy
    .get("/tenantInfo/roleMenuTreeSelect/" + selection.value.data[0].tenantId)
    .then((res) => {
      if (res.code == 200) {
        treeData.value = res.menus;
        formData.treeData = res.checkedKeys;
        tree.value.setCheckedKeys(res.checkedKeys);
      }
    });
};
const tree = ref(null);
const submitTree = () => {
  proxy
    .post("/tenantInfo/bindingMenu", {
      tenantId: selection.value.data[0].tenantId,
      menuIdList: tree.value.getCheckedKeys(),
    })
    .then((res) => {
      ElMessage({
        message: "保存成功",
        type: "success",
      });
      roomDialogVisible.value = false;
    });
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;

    proxy.post("/tdaApplication/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/tdaApplication/detail", { id: row.id }).then((res) => {
    formData.data = res;
    console.log(formData);
    dialogVisible.value = true;
  });
};

const selectData = reactive({
  iotList: [],
});
const getSelect = () => {
  proxy
    .post("/tdaConfig/page", { pageNum: 1, pageSize: 9999 })
    .then((message) => {
      selectData.iotList = message.rows;
      selectConfig[0].data = selectData.iotList.map((x) => ({
        label: x.name,
        value: x.id,
      }));
      formConfig[1].data = selectData.iotList.map((x) => ({
        title: x.name,
        value: x.id,
      }));
    });
};

getList();
getSelect();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>